#BST Create Hole on solid
# Copyright TAK2
# release v1.0   on  20011 / 11 / 28
# v1.01 modified on  20011 / 11 / 29
require 'sketchup.rb'

class BST_HoleOnSolid

def initialize
	#dialogname = "BST Create Hole in Solid"
	#default = ""
	#default = Sketchup.read_default("Structure Tool", "CreateHole")
	#list_yesno=["YES","NO"].join("|")
	#if default == "" or default == nil
	#	default = list_yesyno.split("|")[0]
	#elsif not list_yesyno.split("|").index(default)
	#	default = list_yesyno.split("|")[0]
	#end
	#prompts=["Erase clicked face for hole:" ]
	#dropdowns=[list_yesno]
	#values=[ "NO" ]			
	#results = []
	#results=inputbox( prompts , values, dropdowns, dialogname )
	#@eraseface = results[0]
	@eraseface = "NO"
	#@holeoffset = 0.0
	#@holeoffset = result[1].to_l if result[1].to_l
	#return nil if not results
    #Sketchup.write_default("Structure Tool", "CreateHole", default )
	
    reset
end

def reset
    @state = 0
	Sketchup.active_model.selection.clear
	Sketchup::set_status_text "Select 1st Solid"
end

def activate
	self.reset
end
def get_entitiesbounds( ents )
	ents2 = ents.find_all{|e| e.kind_of? Sketchup::Drawingelement }
	ptmax = [0,0,0]
	ptmin = [0,0,0]
	chk = false
	ents2.each{|e|
		if chk == false
			ptmax = e.bounds.max
			ptmin = e.bounds.min
			chk = true
		else
			ptmax.x = e.bounds.max.x if ptmax.x < e.bounds.max.x
			ptmax.y = e.bounds.max.y if ptmax.y < e.bounds.max.y
			ptmax.z = e.bounds.max.z if ptmax.z < e.bounds.max.z
			
			ptmin.x = e.bounds.min.x if ptmin.x > e.bounds.min.x
			ptmin.y = e.bounds.min.y if ptmin.y > e.bounds.min.y
			ptmin.z = e.bounds.min.z if ptmin.z > e.bounds.min.z
		end
	}
	return ptmax , ptmin
end

def subtract_start(view)
	subtract_form_MS( @ce , @ce2 )
	view.invalidate
end
def subtract_form_MS( cform , cface )
	if cform.kind_of? Sketchup::Group
		subtract_form( cform , cform , cform.entities , cface )
	elsif cform.kind_of? Sketchup::ComponentInstance
		subtract_form( cform , cform.definition , cform.definition.entities , cface )
	end
	if @eraseface == "YES"
		klist = cface.edges
		klist.push cface
		cface.parent.entities.erase_entities klist
	end
end
def subtract_form( cform , cdef , cents , cface1 )
	Sketchup.active_model.start_operation "Solid cut openning"
	cftr = cform.transformation
	cfvts = cface1.outer_loop.vertices.map{|vt| vt.position.transform( cftr.inverse ) } ##.position.transform( cftr ) 
	model = Sketchup.active_model
	ents = model.active_entities
	#ソリッド内の頂点を面１に投影したときの距離と方向の判定
	vt_in_fc = []
	vtlist_ori = []
	vthash_ori = Hash.new
	#edlist_ori = []
	#fclist_ori = []
	cfgrp = cents.add_group
	cface = cfgrp.entities.add_face cfvts

	cfgtr = cfgrp.transformation
	
	nvec1 = cface.normal.transform( cfgtr ).normalize
	nvec2 = nvec1.reverse
	nplane = [ cface.vertices[0].position.transform( cfgtr ) , nvec1 ]
	dist1 = 0.0
	dist2 = 0.0
	vtlist_ori = []

	cents.each{|e|
		if e.kind_of? Sketchup::Face
			e.vertices.each{|vt|
				vthash_ori[ vt.entityID ] = vt if vthash_ori.key?( vt.entityID ) != true
			}
		end
	}

	vthash_ori.each{|eid , e|
		pt1 = e.position
		pt2 = pt1.project_to_plane( nplane )
		pt2fc = pt2.transform( cfgtr )#pt2がcfgrp内の場合の位置
		dist3 = pt1.distance_to_plane( nplane )
		ppvec = pt2.vector_to( pt1).normalize
		if cface.classify_point( pt2fc ) < 16
			#面１の範囲に入っている場合その頂点を登録
			vt_in_fc.push e
		end
		#p "#{ppvec}::::#{nvec1}"
		if  ppvec == nvec1
			#p "a:#{dist3}"
			dist1 = dist3 if dist1 < dist3
		elsif ppvec == nvec2
			#p "b:#{dist3}"
			dist2 = dist3 if dist2 < dist3
		else
			#p "c:#{dist3}"
			dist1 = dist3 if dist1 < dist3
			dist2 = dist3 if dist2 < dist3
		end		
	}
	
	dist1 = dist1 + 100.mm
	dist2 = dist2 + 100.mm

	cface.pushpull dist1
	cface.pushpull dist2

	kill_fcs = []
	lp_fc1 = []
	#cfgrp中のいらない面（当初の面と同じ向きの面）の削除のリストを作る
	cfgrp.entities.each{|fc|
		if fc.kind_of? Sketchup::Face
			#今後のために面は反転しておく
			fc.reverse!
			if fc.normal.parallel?( nvec1 )
				kill_fcs.push fc
			end
		end
	}
	#cfgrp中のいらない面（当初の面と同じ向きの面）の削除の実行
	if kill_fcs.size > 0
		#p "killfaces:#{kill_fcs.size}"
		lp_fc1 = kill_fcs[0].outer_loop.vertices.map{|vt| vt.position.transform cfgtr }
		cfgrp.entities.erase_entities kill_fcs
	end

	kill_eds = []
	cfgrp.entities.each{|ed|
		if ed.kind_of? Sketchup::Edge
			if ed.faces.size == 0
				kill_eds.push ed
			elsif ed.faces.size == 1 
			elsif ed.faces[0].normal.normalize == ed.faces[1].normal.normalize
				#エッジに接続する面同士が平行な場合に登録する
				kill_eds.push ed
			end
		end
	}
	cfgrp.entities.erase_entities kill_eds

	
	vtlist_sub = []
	vthash_sub = Hash.new
	#edlist_sub = []
	#fclist_sub = []
	cfgrp.entities.each{|e|
		if e.kind_of? Sketchup::Edge
			#edlist_sub.push e
		elsif e.kind_of? Sketchup::Face
			#fclist_sub.push e
			e.vertices.each{|vt|
				vthash_sub[ vt.entityID ] = vt if vthash_sub.key?( vt.entityID ) != true
			}
		end
	}
	vtlist_sub = vthash_sub.values
	#元要素群.intersect_with( 元要素群に交差を反映するか？ , 元要素群のtransformation ,　交差を反映したい要素群２ , 要素群２のtransformation , 交差に使われた要素を隠すか？ ,　交差する要素群 )
	#cfgrp.entities.intersect_with( false , cfgrp.transformation * cftr , cform , cftr, false , cform )
	#cents.intersect_with( false , Geom::Transformation.new , cfgrp , cfgrp.transformation , false , cfgrp )
	cfgrp.entities.intersect_with( false , cfgrp.transformation * cftr , cdef , cftr, false , cform )
	cents.intersect_with( false , Geom::Transformation.new , cfgrp , cfgrp.transformation , false , cfgrp )
	cfgrp.explode
	#上手く面と面が馴染まないことがあるので自己交差しておく
	cents.intersect_with( false , cftr , cdef , cftr , false , cform )

	#削除範囲の面を再作成
	void_fc = cents.add_face lp_fc1
	voidplane = void_fc.plane

	#killfcsの範囲にいる各面を削除するためのリストを作成
	kill_fcs = []
	cents.each{|e|
		if e.kind_of? Sketchup::Face
			if e.normal.perpendicular?( void_fc.normal )
			else
				chk = false
				e.loops.each{|lp|
					lp.vertices.each{|vt|
						pt1 = vt.position
						pt2 = pt1.project_to_plane( voidplane )
						if void_fc.classify_point( pt2 ) > 7
							#１つでも点が削除面範囲に入っていない場合は削除対象ではない
							chk = true
						end
					}
				}
				if chk == false
					kill_fcs.push e
				end
			end
		end
	}
	cents.erase_entities kill_fcs
	#２面以下の面と接しているエッジを削除する
	3.times{
	kills = []
		cents.each{|e|
			if e.kind_of? Sketchup::Edge
				kills.push e if e.faces.size < 2
			end
		}
		cents.erase_entities kills	if kills.size > 0
	}
	Sketchup.active_model.selection.clear
	kills = []
		cents.each{|e|
			if e.kind_of? Sketchup::Face
				edcount = 0
				e.edges.each{|ed|
					edcount += 1 if ed.faces.size == 2
				}
				#面が持つすべての辺のうち、２面に接している辺が２つ以下のものを消す
				#これは中空にいる面を削除する方法
				if edcount < 3
					kills.push e
				end
			end
		}
		cents.erase_entities kills	if kills.size > 0
	
	#残っているエッジで２面未満に接してるものは削除
	kills = []
		cents.each{|e|
			if e.kind_of? Sketchup::Edge
				kills.push e if e.faces.size < 2
			end
		}
		cents.erase_entities kills	if kills.size > 0

	Sketchup.active_model.commit_operation
	if cform.deleted? or cform.volume <= 0.0
		Sketchup.undo
		UI.messagebox "Sorry.The operation makes error.So it aborted."
	end
end

def increment_state(view)
    @state += 1
    case @state
    when 1
        Sketchup::set_status_text "Select face for hole"
    when 2
        self.subtract_start(view)
        self.reset
    end
end

def onMouseMove(flags, x, y, view)

end

def onLButtonDown(flags, x, y, view)
	ph = view.pick_helper
	ph.do_pick x,y
	pe = ph.best_picked

	model = Sketchup.active_model
	cmodel = model.active_entities.parent
  case @state
  when 0
	if pe.kind_of? Sketchup::ComponentInstance or pe.kind_of? Sketchup::Group
		if pe.volume > 0.0
			@ce = pe.make_unique
			Sketchup.active_model.selection.add @ce
			self.increment_state(view)
		end
	end
  when 1
	if pe.kind_of? Sketchup::Face
		@ce2 = pe
		Sketchup.active_model.selection.add @ce2
		self.increment_state(view)
	end
  end
end
end # of class

unless( file_loaded?( File.basename(__FILE__) ) )
	pdir = File.dirname( File.expand_path(__FILE__) )
	UI.menu.add_item("Hole On Solid" ) { Sketchup.active_model.select_tool BST_HoleOnSolid.new }
	hos_tb = UI::Toolbar.new("Hole On Solid")
	cmd_hos = UI::Command.new( "Hole On Solid" ) { Sketchup.active_model.select_tool BST_HoleOnSolid.new }
	cmd_hos.large_icon = cmd_hos.small_icon = pdir+"/icon_openning_lg.png"
	cmd_hos.status_bar_text = cmd_hos.tooltip = "Hole On Solid"
	hos_tb.add_item( cmd_hos )
	hos_tb.show if hos_tb.get_last_state != 0
end
file_loaded(File.basename(__FILE__))